Lattice Grid Buy a licence

demo D171

Click a chart to filter

Click a slice and the grid narrows to it

chart.on('click', …)

Building…
Loading a live grid…

The configuration

import * as ng from '@angular/core';
import { Component, ViewChild, AfterViewInit } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { createGrid } from '@toclocoinc/lattice-grid';
import '@toclocoinc/lattice-grid/css';
import { createChart } from '@toclocoinc/lattice-grid/modules/charts';
import createLatticeGrid from '@toclocoinc/lattice-grid/modules/angular';

const { LatticeGridComponent } = createLatticeGrid({ ng, createGrid });

const columns = [
  { field: 'circuit', title: 'Circuit', layout: { width: 180 } },
  { field: 'region', title: 'Region', filter: { type: 'set' } },
  { field: 'status', title: 'Status', filter: { type: 'set' } },
  { field: 'bandwidth', title: 'Bandwidth', type: 'number' },
  { field: 'charge', title: 'Monthly charge', type: 'number',
    format: { style: 'currency', currency: 'GBP' }, total: 'sum' },
];

const rows = [/* circuit records */];



@Component({
  selector: 'app-root',
  standalone: true,
  imports: [LatticeGridComponent],
  template:
    '<div id="chart" style="height:260px"></div>' +
    '<lattice-grid [config]="grid" style="display:block;height:320px;margin-top:14px"></lattice-grid>',
})
export class AppComponent implements AfterViewInit {
  @ViewChild(LatticeGridComponent) gridRef!: LatticeGridComponent;

  grid = {
    rowKey: 'id',
    toolPanel: { side: 'left', panels: ['filters', 'columns'], exportName: 'circuits' },
    columns: columns,
    rows: rows,
  };

  ngAfterViewInit() {
    const grid = this.gridRef.grid;
    const chart = createChart({ grid, container: '#chart', type: 'pie', x: 'status', y: 'charge',
      title: 'Charge by status (click to filter)' });

    // Click a slice to filter the grid to it; click the same slice again to
    // clear. The chart reads the grid, so the bars redraw as the filter lands.
    let active = null;
    chart.on('click', ({ category }) => {
      const value = category;
      if (value == null) return;
      if (active === value) {
        grid.filters?.clear?.();
        active = null;
      } else {
        grid.filters?.set?.({ col: 'status', op: 'eq', value });
        active = value;
      }
    });
  }
}

bootstrapApplication(AppComponent);

Lattice Grid Buy a licence

demo D171

Click a chart to filter

Click a slice and the grid narrows to it

chart.on('click', …)

Building…
Loading a live grid…

The configuration

<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/lattice-grid.min.css">

<div id="app"></div>

<script type="module">
  import React from 'https://esm.sh/react@18';
  import { createRoot } from 'https://esm.sh/react-dom@18/client';
  import { createGrid } from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/lattice-grid.esm.min.js';
  import createLatticeGrid from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/modules/react.esm.min.js';
  import { createChart } from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/modules/charts.esm.min.js';

  const LatticeGrid = createLatticeGrid({ React, createGrid });

  const columns = [
    { field: 'circuit', title: 'Circuit', layout: { width: 180 } },
    { field: 'region', title: 'Region', filter: { type: 'set' } },
    { field: 'status', title: 'Status', filter: { type: 'set' } },
    { field: 'bandwidth', title: 'Bandwidth', type: 'number' },
    { field: 'charge', title: 'Monthly charge', type: 'number',
      format: { style: 'currency', currency: 'GBP' }, total: 'sum' },
  ];

  const rows = [/* circuit records */];

  function App() {
    const gridRef = React.useRef(null);

    React.useEffect(() => {
      const grid = gridRef.current.grid;
      const chart = createChart({ grid, container: '#chart', type: 'pie', x: 'status', y: 'charge',
        title: 'Charge by status (click to filter)' });

      // Click a slice to filter the grid to it; click the same slice again to
      // clear. The chart reads the grid, so the bars redraw as the filter lands.
      let active = null;
      chart.on('click', ({ category }) => {
        const value = category;
        if (value == null) return;
        if (active === value) {
          grid.filters?.clear?.();
          active = null;
        } else {
          grid.filters?.set?.({ col: 'status', op: 'eq', value });
          active = value;
        }
      });
    }, []);

    return (
      <>
        <div id="chart" style={{ height: '260px' }} />
        <LatticeGrid
          ref={gridRef}
          rowKey="id"
          toolPanel={{ side: 'left', panels: ['filters', 'columns'], exportName: 'circuits' }}
          columns={columns}
          rows={rows}
          style={{ height: '320px', marginTop: '14px' }}
        />
      </>
    );
  }

  createRoot(document.getElementById('app')).render(<App />);
</script>